

local f = CreateFrame ("frame")
local CONST_MAX_IGNORED_PLAYERS = 50

function f.SendMessage (m)
	print ("|cFFFF5500[AntiSpamBot]|r:", m)
end

local unregister_chat = function ()
	f:UnregisterEvent ("CHAT_MSG_SYSTEM")
	f.LastInviteFrom = nil
end

local is_friend = function (who)
	local friends_amt = GetNumFriends()
	for i = 1, friends_amt do
		local toonName = GetFriendInfo (i)
		if (who == toonName) then
			return true
		end
	end
end

local remove_ignore = function (bot_name)
	if (bot_name) then
		DelIgnore (bot_name)
		AntiSpamBotDB.IgnoreList [bot_name] = nil
	end
end

local schedule_remove_ignore = function()
	local player = tremove (f.schedule_to_remove)
	remove_ignore (player)
	if (f.RemoveIgnoreTicker and (#f.schedule_to_remove < 1 or f.RemoveIgnoreTicker._remainingIterations < 1)) then
		f.RemoveIgnoreTicker:Cancel()
		f.RemoveIgnoreTicker = nil
	end
end

local on_ignore = function()
	--> if we filled 90% of the total ignore list size, let's clean up our ignores
	if ((GetNumIgnores() > CONST_MAX_IGNORED_PLAYERS * 0.8) and not f.RemoveIgnoreTicker) then
	--if ((GetNumIgnores() > CONST_MAX_IGNORED_PLAYERS * 0.00001) and not f.RemoveIgnoreTicker) then
		local schedule_to_remove = {}
		for bot_name, _ in pairs (AntiSpamBotDB.IgnoreList) do
			tinsert (schedule_to_remove, bot_name)
		end
		if (#schedule_to_remove > 0) then
			f.SendMessage ("your ignore list is almost full, we'll remove few ignored bots now.")
			f.schedule_to_remove = schedule_to_remove
			f.RemoveIgnoreTicker = C_Timer.NewTicker (1, schedule_remove_ignore, #schedule_to_remove)
		end
	end
end

local handle_invite = function (from)

	--> check is the guy is thrusted
	if (AntiSpamBotDB.WhiteList [string.lower (from)]) then
		return
	end

	--> read the actor name and search for a pattern
	local NameStartWithBLetter = from:find ("B") or from:find ("")
	if (NameStartWithBLetter == 1) then
		--	Blizzaed
		--	Blizzacd
		--	Bizzacd
		--	Bllzard
		--	Biizzazd
		
		--> we can't report because CanComplainChat() is false for invite requests
	
		--print (1)
		local HasZ = from:find ("z")
		if (HasZ) then
			--print (2)
			local HasD = from:find ("d")
			if (HasD) then
				--print (3)
				local HasI = from:find ("i") or from:find ("") or from:find ("") or from:find ("")
				local HasL = from:find ("l")
				if (HasI or HasL) then
					--print (4)
					local HasA = from:find ("a") or from:find ("") or from:find ("")  or from:find ("")
					if (HasA) then
						--print (5)
						if (is_friend (from)) then
							f.SendMessage (from .. " is in your friends list and we won't block the invite.")
							return
						end
						
						DeclineGroup()
						
						if (LFGInvitePopup and LFGInvitePopup:IsShown() and LFGInvitePopupText) then
							local text = LFGInvitePopupText:GetText()
							if (text:find (name)) then
								LFGInvitePopup:Hide()
							end
						end
						
						StaticPopup_Hide ("PARTY_INVITE")
						StaticPopup_Hide ("PARTY_INVITE_XREALM")
						
						AntiSpamBotDB.IgnoreList [from] = true
						AddIgnore (from)
						C_Timer.After (5, on_ignore)
						
						return
					end
				end
			end
		end
	end
	
	--> the pattern didn't match up, /who the source of the invite
	f:RegisterEvent ("CHAT_MSG_SYSTEM")
	f.LastInviteFrom = from
	SendWho (from)
	--> only wait 2 seconds
	C_Timer.After (2, unregister_chat)
end

local handle_chat_message = function (text)

	if (f.LastInviteFrom) then
		--> try to get who results
		for i = 1, GetNumWhoResults() do
			local name, guild, level, race, class, zone, classFileName, sex = GetWhoInfo (i)
			
			--> is the guy who sent the invite?
			if (name and name == f.LastInviteFrom) then
				
				--> if is a DK level 55, might be a spam bot
				if (level == 55 and classFileName == "DEATHKNIGHT") then
					if (is_friend (name)) then
						f.SendMessage (name .. " is in your friends list and we won't block the invite.")
						return
					end
					
					DeclineGroup()
					
					if (LFGInvitePopup and LFGInvitePopup:IsShown() and LFGInvitePopupText) then
						local text = LFGInvitePopupText:GetText()
						if (text:find (name)) then
							LFGInvitePopup:Hide()
						end
					end
					
					StaticPopup_Hide ("PARTY_INVITE")
					StaticPopup_Hide ("PARTY_INVITE_XREALM")
					
					AntiSpamBotDB.IgnoreList [name] = true
					AddIgnore (name)
					C_Timer.After (5, on_ignore)
					
					f:UnregisterEvent ("CHAT_MSG_SYSTEM")
					f.LastInviteFrom = nil
					
					f.SendMessage (name .. " is a DK level 55, might be a spam bot. If isn't, remove the ignore and add him to your friend list.")
					
					return
				end
			end
		end
	end
	
end

f:SetScript ("OnEvent", function (self, event, from, ...)
	if (event == "CHAT_MSG_SYSTEM") then
		return handle_chat_message (from, ...)

	elseif (event == "PARTY_INVITE_REQUEST") then
		return handle_invite (from)
	
	elseif (event == "PLAYER_LOGIN") then
		AntiSpamBotDB = AntiSpamBotDB or {WhiteList = {}, IgnoreList = {}}
		AntiSpamBotDB.WhiteList = AntiSpamBotDB.WhiteList or {}
		AntiSpamBotDB.IgnoreList = AntiSpamBotDB.IgnoreList or {}
	end
end)

SLASH_AntiSpamBot1 = "/antispambot"
function SlashCmdList.AntiSpamBot (msg, editbox)

	if (msg == "list") then
		f.SendMessage ("Bots caught:")
		for bot_name, _ in pairs (AntiSpamBotDB.IgnoreList) do
			print (bot_name)
		end
		return
	end

	if (string.len (msg) > 14) then
		f.SendMessage (msg .. " is too big to be a character name.")
		return
	end

	msg = string.lower (msg)
	AntiSpamBotDB.WhiteList [msg] = true
	f.SendMessage (msg .. " added to the white list.")
end


f:RegisterEvent ("PARTY_INVITE_REQUEST")
f:RegisterEvent ("PLAYER_LOGIN")
